%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%  Hw1: Create an Avi        %
%  Student:  Bo  Han         %
%  Sep. 11, 2004             %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 0. Initial work          %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%

delete 'hw1.avi';
clear all

% read in 4 images
[smallImg1,imgLength, imgWidth]=readImg('1_1.jpg');

[smallImg2,imgLength, imgWidth]=readImg('1_2.jpg');

[smallImg3,imgLength, imgWidth]=readImg('1_3.jpg');

[smallImg4,imgLength, imgWidth]=readImg('1_4.jpg');

% Generate a black background image
backgImg=zeros(4*imgLength,4*imgWidth,3);
bkgLength = size(backgImg,1);
bkgWidth = size(backgImg,2);

% Create an AVI file
aviFileName = 'hw1';
framesPerSec = '3';

aviobj = avifile(aviFileName,'fps',framesPerSec, 'compression', 'Indeo5'); % initialize .avi file object.

% Add one blank fram at the begining of the AVI
frameObj = im2frame(backgImg);
aviobj = addframe(aviobj,frameObj);

%show movie title
for i = 1:55
    windowPos = [200 200 400 400];
    [x,y,z]=sphere(50);

    h = figure('Position', windowPos, ...
           'Color', 'k', ...
           'NextPlot','replace', ...
           'Visible', 'on');

    axis off;
    
    % show text
    text(0.5,0.8,'Highlights of Athens 2004','FontSize',20,'FontWeight','bold','Color','w','HorizontalAlignment','center');
    text(0.5,0.6,'Summer Olympic Games','FontSize',20,'FontWeight','bold','Color','w','HorizontalAlignment','center');
    text(0.5,0.3,'Instructor: Longin Jan Latecki','FontSize',16,'FontWeight','normal','Color','w','HorizontalAlignment','center');
    text(0.5,0.2,'Student: Bo Han','FontSize',16,'FontWeight','normal','Color','w','HorizontalAlignment','center');
    
    f=getframe(h);
    [imaget,mapt]=frame2im(f);

    imagetem=double(imaget)/255;
    imagetem=putImgInBkg(imagetem,backgImg, [floor(bkgLength-size(imaget,1))/2,floor(bkgWidth-size(imaget,2))/2]);
    % store frame
    aviobj = addframe(aviobj,imagetem);
    close(h)
    clf;
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 1. Horizontal sliding    %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Generate the horizontal slide bar
step=3; 
tempbackgImg = backgImg;
tempImg = double(ones(imgLength, bkgWidth, 3));
posy=floor((bkgLength-imgLength)/2);
for posx = bkgWidth-1:step*-1:1
    posx
    tempImg = putImgInBkg(smallImg1, tempbackgImg, [posy, posx]);
    if(bkgWidth-posx>imgWidth)
      tempImg = putImgInBkg(smallImg2, tempImg, [posy, posx+imgWidth]);
    end
    if(bkgWidth-posx>2*imgWidth)
      tempImg = putImgInBkg(smallImg3, tempImg, [posy, posx+2*imgWidth]);
    end
    if(bkgWidth-posx>3*imgWidth)
      tempImg = putImgInBkg(smallImg4, tempImg, [posy, posx+3*imgWidth]);
    end

    frameObj = im2frame(tempImg);  
    aviobj = addframe(aviobj,frameObj);
end

width=4;
for t=0:width:floor(imgLength/2)+width;
    tempImg=whiteImg(tempImg,t+posy,width);
    tempImg=whiteImg(tempImg,posy+imgLength-t,width);
    frameObj = im2frame(tempImg);  
   aviobj = addframe(aviobj,frameObj);
end

% %%%%%%%%%%%%%%%%%%%%%%%%%
% % 2. Vertical sliding   %
% %%%%%%%%%%%%%%%%%%%%%%%%%

% Generate the horizontal slide bar

tempbackgImg = backgImg;
tempImg = double(ones(imgLength, bkgWidth, 3));
posx=floor((bkgWidth-imgWidth)/2);
for posy = bkgLength-1:step*-1:1
    posy
    tempImg = putImgInBkg(smallImg1, tempbackgImg, [posy, posx]);
    if(bkgLength-posy>imgLength)
      tempImg = putImgInBkg(smallImg2, tempImg, [posy+imgLength, posx]);
    end
    if(bkgLength-posy>2*imgLength)
      tempImg = putImgInBkg(smallImg3, tempImg, [posy+2*imgLength, posx]);
    end
    if(bkgLength-posy>3*imgLength)
      tempImg = putImgInBkg(smallImg4, tempImg, [posy+3*imgLength, posx]);
    end

    frameObj = im2frame(tempImg);  
    aviobj = addframe(aviobj,frameObj);
end

length=4;
for t=0:length:floor(imgWidth/2)+length;
    tempImg=whiteImgX(tempImg,t+posx,length);
    tempImg=whiteImgX(tempImg,posx+imgWidth-t,length);
    frameObj = im2frame(tempImg);  
   aviobj = addframe(aviobj,frameObj);
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%
%3. Iimage 2D rotation    %
%%%%%%%%%%%%%%%%%%%%%%%%%%%

rotateStep = 3;

tempbackgImg = backgImg;
tempImg=tempbackgImg;

for angle =3: rotateStep: 360-rotateStep
    angle
    X = imrotate(smallImg1, angle, 'bilinear', 'crop');
    
    X1 = imresize(X, angle/360,'nearest');
    qt=find(X1>1);
    X1(qt)=1;
    qt=find(X1<0);
    X1(qt)=0;
    Lengtht = size(X1,1);
    Widtht = size(X1,2);    
    tempImg = putImgInBkg(X1, tempImg, [(bkgLength-Lengtht)/4,(bkgWidth-Widtht)/4] );
%    tempImg = putImgInBkg(X1, tempImg, [(bkgLength-Lengtht)/4,(Widtht)/2] );

    X = imrotate(smallImg2, 360-angle, 'bilinear', 'crop');
    
    X1 = imresize(X, angle/360,'nearest');
    qt=find(X1>1);
    X1(qt)=1;
    qt=find(X1<0);
    X1(qt)=0;
    Lengtht = size(X1,1);
    Widtht = size(X1,2);    
    tempImg = putImgInBkg(X1, tempImg, [floor(1.5*imgLength)+(bkgLength-Lengtht)/4,(bkgWidth-Widtht)/4] );
    
    X = imrotate(smallImg3, 360-angle, 'bilinear', 'crop');
    
    X1 = imresize(X, angle/360,'nearest');
    qt=find(X1>1);
    X1(qt)=1;
    qt=find(X1<0);
    X1(qt)=0;
    Lengtht = size(X1,1);
    Widtht = size(X1,2);    
    tempImg = putImgInBkg(X1, tempImg, [(bkgLength-Lengtht)/4,floor(1.5*imgWidth)+(bkgWidth-Widtht)/4] );
    
    X = imrotate(smallImg4, angle, 'bilinear', 'crop');
    
    X1 = imresize(X, angle/360,'nearest');
    qt=find(X1>1);
    X1(qt)=1;
    qt=find(X1<0);
    X1(qt)=0;
    Lengtht = size(X1,1);
    Widtht = size(X1,2);    
    tempImg = putImgInBkg(X1, tempImg, [floor(1.5*imgLength)+(bkgLength-Lengtht)/4,floor(1.5*imgWidth)+(bkgWidth-Widtht)/4] );
    
    frameObj = im2frame(tempImg);  
    aviobj = addframe(aviobj,frameObj);
end

    tempImg = putImgInBkg(smallImg1, tempImg, [(bkgLength-Lengtht)/4,(bkgWidth-Widtht)/4] );
    tempImg = putImgInBkg(smallImg2, tempImg, [floor(1.5*imgLength)+(bkgLength-Lengtht)/4,(bkgWidth-Widtht)/4] );
    tempImg = putImgInBkg(smallImg3, tempImg, [(bkgLength-Lengtht)/4,floor(1.5*imgWidth)+(bkgWidth-Widtht)/4] );
    
    tempImg = putImgInBkg(smallImg4, tempImg, [floor(1.5*imgLength)+(bkgLength-Lengtht)/4,floor(1.5*imgWidth)+(bkgWidth-Widtht)/4] );
    frameObj = im2frame(tempImg);  
    aviobj = addframe(aviobj,frameObj);

%image disappear

tempbackgImg = backgImg;
reducestep=50;
for m=2:reducestep-1
    X1 = imresize(tempImg, 1-m/reducestep,'nearest');
    tempImgt = putImgInBkg(X1, tempbackgImg, [floor(bkgLength-size(X1,1))/2,floor(bkgWidth-size(X1,2))/2]);    
    frameObj = im2frame(tempImgt);  
    aviobj = addframe(aviobj,frameObj);
end

for m=1:10
    frameObj = im2frame(backgImg);
    aviobj = addframe(aviobj,frameObj);
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%
%4. Iimage 3D rotation    %
%%%%%%%%%%%%%%%%%%%%%%%%%%%
tempbackgImg=zeros(4*imgLength,4*imgWidth,3);

for i=1:10
    tempbackgImg(floor(i*0.4*imgLength):floor(i*0.4*imgLength)+2,:,:)=0.6;
end

for i=1:10
    tempbackgImg(:, floor(i*0.4*imgWidth):floor(i*0.4*imgWidth)+2,:)=0.6;
end


s1(:,:,1)=flipud(smallImg1(:,:,1));
s1(:,:,2)=flipud(smallImg1(:,:,2));
s1(:,:,3)=flipud(smallImg1(:,:,3));

s2(:,:,1)=flipud(smallImg2(:,:,1));
s2(:,:,2)=flipud(smallImg2(:,:,2));
s2(:,:,3)=flipud(smallImg2(:,:,3));

s3(:,:,1)=flipud(smallImg3(:,:,1));
s3(:,:,2)=flipud(smallImg3(:,:,2));
s3(:,:,3)=flipud(smallImg3(:,:,3));

s4(:,:,1)=flipud(smallImg4(:,:,1));
s4(:,:,2)=flipud(smallImg4(:,:,2));
s4(:,:,3)=flipud(smallImg4(:,:,3));

tempImg = putImgInBkg(s1, tempbackgImg, [floor(1.5*imgLength), 1]);
tempImg = putImgInBkg(s2, tempImg, [floor(1.5*imgLength), imgWidth]);
tempImg = putImgInBkg(s3, tempImg, [floor(1.5*imgLength), 2*imgWidth]);
tempImg = putImgInBkg(s4, tempImg, [floor(1.5*imgLength), 3*imgWidth]);

windowPos = [200 200 400 400];
[x,y,z]=sphere(50);
x=x*2;
y=y*2;
z=z*2;
h2=surf(x,y,z);

h = figure('Position', windowPos, ...
           'Color', 'k', ...
           'NextPlot','replace', ...
           'Visible', 'on');
hold on;
h2=warp(x,y,z,tempImg);
axis off;

f=getframe(h);
[imaget,mapt]=frame2im(f);
imaget=double(imaget)/255;

%image enlarge
tempbackgImg = backgImg;
enlargestep=50;
for m=1:enlargestep
    X1 = imresize(imaget, m/50,'nearest');
    tempImgt = putImgInBkg(X1, tempbackgImg, [floor(bkgLength-size(X1,1))/2,floor(bkgWidth-size(X1,2))/2]);    
    frameObj = im2frame(tempImgt);  
    aviobj = addframe(aviobj,frameObj);
end

close(h);

rotatestep3d=3;
for i=rotatestep3d:rotatestep3d:360
    i
    h = figure('Position', windowPos, ...
           'Color', 'k', ...
           'NextPlot','replace', ...
           'Visible', 'on');
    hold on;
    h2=warp(x,y,z,tempImg);
    axis off;

    rotate(h2,[0 0 1],i); 
    f=getframe(h);
    [imaget,mapt]=frame2im(f);

    imaget=double(imaget)/255;
    imaget=putImgInBkg(imaget,backgImg, [floor(bkgLength-size(imaget,1))/2,floor(bkgWidth-size(imaget,2))/2]);
    aviobj = addframe(aviobj, imaget);
    close(h);
end

aviobj = close(aviobj);

