%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% This function is used to put a small image into the background image with
% specific position
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function [outputImg] = putImgInBkg(smallImg, bigImg, position)

    smallLength = floor(size(smallImg,1));
    smallWidth = floor(size(smallImg,2));
    bigLength = floor(size(bigImg,1));
    bigWidth = floor(size(bigImg,2));
    position=floor(position);
    
    if (position(1) >= bigLength) | (position(2) >= bigWidth)
        outputImg = bigImg;
        return
    end

    if (position(1) < 0) | (position(2) <0)
        outputImg = bigImg;
        return
    end
    
    bigRowBottom = position(1) + smallLength - 1;
    if bigRowBottom > bigLength
        bigRowBottom = bigLength;
    end
    smallRowBottom = bigRowBottom - position(1) + 1;
    
    bigColRight = position(2) + smallWidth - 1;
    if bigColRight > bigWidth
        bigColRight = bigWidth;
    end
    smallColRight = bigColRight - position(2) + 1;
    
    bigImg(position(1):bigRowBottom, position(2):bigColRight, :)=smallImg(1:smallRowBottom, 1:smallColRight, :);
    outputImg = bigImg;
return;